MagickCore: option.c File Reference

# option.c File Reference

`#include "magick/studio.h"`
`#include "magick/artifact.h"`
`#include "magick/cache.h"`
`#include "magick/color.h"`
`#include "magick/compare.h"`
`#include "magick/constitute.h"`
`#include "magick/distort.h"`
`#include "magick/draw.h"`
`#include "magick/effect.h"`
`#include "magick/exception.h"`
`#include "magick/exception-private.h"`
`#include "magick/fx.h"`
`#include "magick/gem.h"`
`#include "magick/geometry.h"`
`#include "magick/layer.h"`
`#include "magick/mime-private.h"`
`#include "magick/memory_.h"`
`#include "magick/monitor.h"`
`#include "magick/montage.h"`
`#include "magick/option.h"`
`#include "magick/property.h"`
`#include "magick/quantum.h"`
`#include "magick/resource_.h"`
`#include "magick/splay-tree.h"`
`#include "magick/string_.h"`
`#include "magick/token.h"`
`#include "magick/utility.h"`

## Functions
MagickExport MagickBooleanType | CloneImageOptions (ImageInfo *image_info, const ImageInfo *clone_info)
MagickExport MagickBooleanType | DefineImageOption (ImageInfo *image_info, const char *option)
MagickExport MagickBooleanType | DeleteImageOption (ImageInfo *image_info, const char *option)
MagickExport void | DestroyImageOptions (ImageInfo *image_info)
MagickExport const char * | GetImageOption (const ImageInfo *image_info, const char *key)
static const OptionInfo * | GetOptionInfo (const MagickOption option)
MagickExport char ** | GetMagickOptions (const MagickOption value)
MagickExport char * | GetNextImageOption (const ImageInfo *image_info)
MagickExport MagickBooleanType | IsMagickOption (const char *option)
MagickExport const char * | MagickOptionToMnemonic (const MagickOption option, const long type)
MagickExport MagickBooleanType | ListMagickOptions (FILE *file, const MagickOption option, ExceptionInfo *magick_unused(exception))
MagickExport long | ParseChannelOption (const char *channels)
MagickExport long | ParseMagickOption (const MagickOption option, const MagickBooleanType list, const char *options)
MagickExport char * | RemoveImageOption (ImageInfo *image_info, const char *option)
MagickExport void | ResetImageOptionIterator (const ImageInfo *image_info)
MagickExport MagickBooleanType | SetImageOption (ImageInfo *image_info, const char *option, const char *value)
MagickExport MagickBooleanType | SyncImageOptions (const ImageInfo *image_info, Image *image)
## Variables
static const OptionInfo | AlignOptions []
static const OptionInfo | AlphaOptions []
static const OptionInfo | BooleanOptions []
static const OptionInfo | ChannelOptions []
static const OptionInfo | ClassOptions []
static const OptionInfo | ClipPathOptions []
static const OptionInfo | CommandOptions []
static const OptionInfo | ComposeOptions []
static const OptionInfo | CompressOptions []
static const OptionInfo | ColorspaceOptions []
static const OptionInfo | DataTypeOptions []
static const OptionInfo | DecorateOptions []
static const OptionInfo | DisposeOptions []
static const OptionInfo | DistortOptions []
static const OptionInfo | EndianOptions []
static const OptionInfo | EvaluateOptions []
static const OptionInfo | FillRuleOptions []
static const OptionInfo | FilterOptions []
static const OptionInfo | GravityOptions []
static const OptionInfo | IntentOptions []
static const OptionInfo | InterlaceOptions []
static const OptionInfo | InterpolateOptions []
static const OptionInfo | LayerOptions []
static const OptionInfo | LineCapOptions []
static const OptionInfo | LineJoinOptions []
static const OptionInfo | ListOptions []
static const OptionInfo | LogEventOptions []
static const OptionInfo | MetricOptions []
static const OptionInfo | MethodOptions []
static const OptionInfo | ModeOptions []
static const OptionInfo | MogrifyOptions []
static const OptionInfo | NoiseOptions []
static const OptionInfo | OrientationOptions []
static const OptionInfo | PreviewOptions []
static const OptionInfo | PrimitiveOptions []
static const OptionInfo | QuantumFormatOptions []
static const OptionInfo | ResolutionOptions []
static const OptionInfo | ResourceOptions []
static const OptionInfo | StorageOptions []
static const OptionInfo | StretchOptions []
static const OptionInfo | StyleOptions []
static const OptionInfo | TypeOptions []
static const OptionInfo | VirtualPixelOptions []

## Function Documentation

MagickExport MagickBooleanType CloneImageOptions | ( | ImageInfo * | image_info,
|  | const ImageInfo * | clone_info |
| ) |  |  |

MagickExport MagickBooleanType DefineImageOption | ( | ImageInfo * | image_info,
|  | const char * | option |
| ) |  |  |

MagickExport MagickBooleanType DeleteImageOption | ( | ImageInfo * | image_info,
|  | const char * | option |
| ) |  |  |

MagickExport void DestroyImageOptions | ( | ImageInfo * | image_info | ) |

MagickExport const char* GetImageOption | ( | const ImageInfo * | image_info,
|  | const char * | key |
| ) |  |  |

MagickExport char** GetMagickOptions | ( | const MagickOption | value | ) |

MagickExport char* GetNextImageOption | ( | const ImageInfo * | image_info | ) |

static const OptionInfo* GetOptionInfo | ( | const MagickOption | option | ) | `[static]`

MagickExport MagickBooleanType IsMagickOption | ( | const char * | option | ) |

MagickExport MagickBooleanType ListMagickOptions | ( | FILE * | file,
|  | const MagickOption | option,
|  | ExceptionInfo * | magick_unused(exception) |
| ) |  |  |

MagickExport const char* MagickOptionToMnemonic | ( | const MagickOption | option,
|  | const long | type |
| ) |  |  |

MagickExport long ParseChannelOption | ( | const char * | channels | ) |

MagickExport long ParseMagickOption | ( | const MagickOption | option,
|  | const MagickBooleanType | list,
|  | const char * | options |
| ) |  |  |

MagickExport char* RemoveImageOption | ( | ImageInfo * | image_info,
|  | const char * | option |
| ) |  |  |

MagickExport void ResetImageOptionIterator | ( | const ImageInfo * | image_info | ) |

MagickExport MagickBooleanType SetImageOption | ( | ImageInfo * | image_info,
|  | const char * | option,
|  | const char * | value |
| ) |  |  |

MagickExport MagickBooleanType SyncImageOptions | ( | const ImageInfo * | image_info,
|  | Image * | image |
| ) |  |  |

## Variable Documentation

const OptionInfo AlignOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedAlign },
        { "Center", (long) CenterAlign },
        { "End", (long) RightAlign },
        { "Left", (long) LeftAlign },
        { "Middle", (long) CenterAlign },
        { "Right", (long) RightAlign },
        { "Start", (long) LeftAlign },
        { (char *) NULL, (long) UndefinedAlign }
      }

const OptionInfo AlphaOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedAlphaChannel },
        { "Activate", (long) ActivateAlphaChannel },
        { "Deactivate", (long) DeactivateAlphaChannel },
        { "Off", (long) DeactivateAlphaChannel },
        { "On", (long) ActivateAlphaChannel },
        { "Reset", (long) ResetAlphaChannel },
        { "Set", (long) SetAlphaChannel },
        { (char *) NULL, (long) UndefinedAlphaChannel }
      }

const OptionInfo BooleanOptions[]`[static]`

Initial value:

      {
        { "False", 0L },
        { "True", 1L },
        { "0", 0L },
        { "1", 1L },
        { (char *) NULL, 0L }
      }

const OptionInfo ChannelOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedChannel },
        { "All", (long) AllChannels },
        { "Alpha", (long) OpacityChannel },
        { "Black", (long) BlackChannel },
        { "Blue", (long) BlueChannel },
        { "Cyan", (long) CyanChannel },
        { "Default", (long) DefaultChannels },
        { "Gray", (long) GrayChannel },
        { "Green", (long) GreenChannel },
        { "Hue", (long) RedChannel },
        { "Index", (long) IndexChannel },
        { "Luminance", (long) BlueChannel },
        { "Luminosity", (long) BlueChannel },
        { "Magenta", (long) MagentaChannel },
        { "Matte", (long) OpacityChannel },
        { "Opacity", (long) OpacityChannel },
        { "Red", (long) RedChannel },
        { "Saturation", (long) GreenChannel },
        { "Yellow", (long) YellowChannel },
        { (char *) NULL, (long) UndefinedChannel }
      }

const OptionInfo ClassOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedClass },
        { "DirectClass", (long) DirectClass },
        { "PseudoClass", (long) PseudoClass },
        { (char *) NULL, (long) UndefinedClass }
      }

const OptionInfo ClipPathOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedPathUnits },
        { "ObjectBoundingBox", (long) ObjectBoundingBox },
        { "UserSpace", (long) UserSpace },
        { "UserSpaceOnUse", (long) UserSpaceOnUse },
        { (char *) NULL, (long) UndefinedPathUnits }
      }

const OptionInfo ColorspaceOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedColorspace },
        { "CMY", (long) CMYColorspace },
        { "CMYK", (long) CMYKColorspace },
        { "Gray", (long) GRAYColorspace },
        { "HSB", (long) HSBColorspace },
        { "HSL", (long) HSLColorspace },
        { "HWB", (long) HWBColorspace },
        { "Lab", (long) LabColorspace },
        { "Log", (long) LogColorspace },
        { "OHTA", (long) OHTAColorspace },
        { "Rec601Luma", (long) Rec601LumaColorspace },
        { "Rec601YCbCr", (long) Rec601YCbCrColorspace },
        { "Rec709Luma", (long) Rec709LumaColorspace },
        { "Rec709YCbCr", (long) Rec709YCbCrColorspace },
        { "RGB", (long) RGBColorspace },
        { "sRGB", (long) sRGBColorspace },
        { "Transparent", (long) TransparentColorspace },
        { "XYZ", (long) XYZColorspace },
        { "YCbCr", (long) YCbCrColorspace },
        { "YCC", (long) YCCColorspace },
        { "YIQ", (long) YIQColorspace },
        { "YPbPr", (long) YPbPrColorspace },
        { "YUV", (long) YUVColorspace },
        { (char *) NULL, (long) UndefinedColorspace }
      }

const OptionInfo CommandOptions[]`[static]`

const OptionInfo ComposeOptions[]`[static]`

const OptionInfo CompressOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedCompression },
        { "BZip", (long) BZipCompression },
        { "Fax", (long) FaxCompression },
        { "Group4", (long) Group4Compression },
        { "JPEG", (long) JPEGCompression },
        { "JPEG2000", (long) JPEG2000Compression },
        { "Lossless", (long) LosslessJPEGCompression },
        { "LosslessJPEG", (long) LosslessJPEGCompression },
        { "LZW", (long) LZWCompression },
        { "None", (long) NoCompression },
        { "RLE", (long) RLECompression },
        { "Zip", (long) ZipCompression },
        { "RunlengthEncoded", (long) RLECompression },
        { (char *) NULL, (long) UndefinedCompression }
      }

const OptionInfo DataTypeOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedData },
        { "Byte", (long) ByteData },
        { "Long", (long) LongData },
        { "Short", (long) ShortData },
        { "String", (long) StringData },
        { (char *) NULL, (long) UndefinedData }
      }

const OptionInfo DecorateOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedDecoration },
        { "LineThrough", (long) LineThroughDecoration },
        { "None", (long) NoDecoration },
        { "Overline", (long) OverlineDecoration },
        { "Underline", (long) UnderlineDecoration },
        { (char *) NULL, (long) UndefinedDecoration }
      }

const OptionInfo DisposeOptions[]`[static]`

Initial value:

      {
        { "Background", (long) BackgroundDispose },
        { "None", (long) NoneDispose },
        { "Previous", (long) PreviousDispose },
        { "Undefined", (long) UndefinedDispose },
        { "0", (long) UndefinedDispose },
        { "1", (long) NoneDispose },
        { "2", (long) BackgroundDispose },
        { "3", (long) PreviousDispose },
        { (char *) NULL, (long) UndefinedDispose }
      }

const OptionInfo DistortOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedDistortion },
        { "Affine", (long) AffineDistortion },
        { "AffineProjection", (long) AffineProjectionDistortion },
        { "Bilinear", (long) BilinearDistortion },
        { "Perspective", (long) PerspectiveDistortion },
        { "PerspectiveProjection", (long) PerspectiveProjectionDistortion },
        { "ScaleRotateTranslate", (long) ScaleRotateTranslateDistortion },
        { "SRT", (long) ScaleRotateTranslateDistortion },
        { "Arc", (long) ArcDistortion },
        { (char *) NULL, (long) UndefinedDistortion }
      }

const OptionInfo EndianOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedEndian },
        { "LSB", (long) LSBEndian },
        { "MSB", (long) MSBEndian },
        { (char *) NULL, (long) UndefinedEndian }
      }

const OptionInfo EvaluateOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedEvaluateOperator },
        { "Add", (long) AddEvaluateOperator },
        { "And", (long) AndEvaluateOperator },
        { "Divide", (long) DivideEvaluateOperator },
        { "LeftShift", (long) LeftShiftEvaluateOperator },
        { "Max", (long) MaxEvaluateOperator },
        { "Min", (long) MinEvaluateOperator },
        { "Multiply", (long) MultiplyEvaluateOperator },
        { "Or", (long) OrEvaluateOperator },
        { "RightShift", (long) RightShiftEvaluateOperator },
        { "Set", (long) SetEvaluateOperator },
        { "Subtract", (long) SubtractEvaluateOperator },
        { "Xor", (long) XorEvaluateOperator },
        { (char *) NULL, (long) UndefinedEvaluateOperator }
      }

const OptionInfo FillRuleOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedRule },
        { "Evenodd", (long) EvenOddRule },
        { "NonZero", (long) NonZeroRule },
        { (char *) NULL, (long) UndefinedRule }
      }

const OptionInfo FilterOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedFilter },
        { "Bartlett", (long) BartlettFilter },
        { "Bessel", (long) BesselFilter },
        { "Blackman", (long) BlackmanFilter },
        { "Bohman", (long) BohmanFilter },
        { "Box", (long) BoxFilter },
        { "Catrom", (long) CatromFilter },
        { "Cubic", (long) CubicFilter },
        { "Gaussian", (long) GaussianFilter },
        { "Hamming", (long) HammingFilter },
        { "Hanning", (long) HanningFilter },
        { "Hermite", (long) HermiteFilter },
        { "Kaiser", (long) KaiserFilter },
        { "Lagrange", (long) LagrangeFilter },
        { "Lanczos", (long) LanczosFilter },
        { "Mitchell", (long) MitchellFilter },
        { "Parzen", (long) ParzenFilter },
        { "Point", (long) PointFilter },
        { "Quadratic", (long) QuadraticFilter },
        { "Sinc", (long) SincFilter },
        { "Triangle", (long) TriangleFilter },
        { "Welsh", (long) WelshFilter },
        { (char *) NULL, (long) UndefinedFilter }
      }

const OptionInfo GravityOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedGravity },
        { "None", (long) UndefinedGravity },
        { "Center", (long) CenterGravity },
        { "East", (long) EastGravity },
        { "Forget", (long) ForgetGravity },
        { "NorthEast", (long) NorthEastGravity },
        { "North", (long) NorthGravity },
        { "NorthWest", (long) NorthWestGravity },
        { "SouthEast", (long) SouthEastGravity },
        { "South", (long) SouthGravity },
        { "SouthWest", (long) SouthWestGravity },
        { "West", (long) WestGravity },
        { "Static", (long) StaticGravity },
        { (char *) NULL, UndefinedGravity }
      }

const OptionInfo IntentOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedIntent },
        { "Absolute", (long) AbsoluteIntent },
        { "Perceptual", (long) PerceptualIntent },
        { "Relative", (long) RelativeIntent },
        { "Saturation", (long) SaturationIntent },
        { (char *) NULL, (long) UndefinedIntent }
      }

const OptionInfo InterlaceOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedInterlace },
        { "Line", (long) LineInterlace },
        { "None", (long) NoInterlace },
        { "Plane", (long) PlaneInterlace },
        { "Partition", (long) PartitionInterlace },
        { "GIF", (long) GIFInterlace },
        { "JPEG", (long) JPEGInterlace },
        { "PNG", (long) PNGInterlace },
        { (char *) NULL, (long) UndefinedInterlace }
      }

const OptionInfo InterpolateOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedInterpolatePixel },
        { "Average", (long) AverageInterpolatePixel },
        { "Bicubic", (long) BicubicInterpolatePixel },
        { "Bilinear", (long) BilinearInterpolatePixel },
        { "filter", (long) FilterInterpolatePixel },
        { "Integer", (long) IntegerInterpolatePixel },
        { "Mesh", (long) MeshInterpolatePixel },
        { "NearestNeighbor", (long) NearestNeighborInterpolatePixel },
        { "Spline", (long) SplineInterpolatePixel },
        { (char *) NULL, (long) UndefinedInterpolatePixel }
      }

const OptionInfo LayerOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedLayer },
        { "Coalesce", (long) CoalesceLayer },
        { "CompareAny", (long) CompareAnyLayer },
        { "CompareClear", (long) CompareClearLayer },
        { "CompareOverlay", (long) CompareOverlayLayer },
        { "Dispose", (long) DisposeLayer },
        { "Optimize", (long) OptimizeLayer },
        { "OptimizeFrame", (long) OptimizeImageLayer },
        { "OptimizePlus", (long) OptimizePlusLayer },
        { "OptimizeTransparency", (long) OptimizeTransLayer },
        { "RemoveDups", (long) RemoveDupsLayer },
        { "RemoveZero", (long) RemoveZeroLayer },
        { "Composite", (long) CompositeLayer },
        { "Merge", (long) MergeLayer },
        { "Flatten", (long) FlattenLayer },
        { "Mosaic", (long) MosaicLayer },
        { (char *) NULL, (long) UndefinedLayer }
      }

const OptionInfo LineCapOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedCap },
        { "Butt", (long) ButtCap },
        { "Round", (long) RoundCap },
        { "Square", (long) SquareCap },
        { (char *) NULL, (long) UndefinedCap }
      }

const OptionInfo LineJoinOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedJoin },
        { "Bevel", (long) BevelJoin },
        { "Miter", (long) MiterJoin },
        { "Round", (long) RoundJoin },
        { (char *) NULL, (long) UndefinedJoin }
      }

const OptionInfo ListOptions[]`[static]`

const OptionInfo LogEventOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedEvents },
        { "All", (long) (AllEvents &~ TraceEvent) },
        { "Annotate", (long) AnnotateEvent },
        { "Blob", (long) BlobEvent },
        { "Cache", (long) CacheEvent },
        { "Coder", (long) CoderEvent },
        { "Configure", (long) ConfigureEvent },
        { "Deprecate", (long) DeprecateEvent },
        { "Draw", (long) DrawEvent },
        { "Exception", (long) ExceptionEvent },
        { "Locale", (long) LocaleEvent },
        { "Module", (long) ModuleEvent },
        { "None", (long) NoEvents },
        { "Resource", (long) ResourceEvent },
        { "Trace", (long) TraceEvent },
        { "Transform", (long) TransformEvent },
        { "User", (long) UserEvent },
        { "Wand", (long) WandEvent },
        { "X11", (long) X11Event },
        { (char *) NULL, (long) UndefinedEvents }
      }

const OptionInfo MethodOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedMethod },
        { "FillToBorder", (long) FillToBorderMethod },
        { "Floodfill", (long) FloodfillMethod },
        { "Point", (long) PointMethod },
        { "Replace", (long) ReplaceMethod },
        { "Reset", (long) ResetMethod },
        { (char *) NULL, (long) UndefinedMethod }
      }

const OptionInfo MetricOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedMetric },
        { "AE", (long) AbsoluteErrorMetric },
        { "MAE", (long) MeanAbsoluteErrorMetric },
        { "MEPP", (long) MeanErrorPerPixelMetric },
        { "MSE", (long) MeanSquaredErrorMetric },
        { "PAE", (long) PeakAbsoluteErrorMetric },
        { "PSNR", (long) PeakSignalToNoiseRatioMetric },
        { "RMSE", (long) RootMeanSquaredErrorMetric },
        { (char *) NULL, (long) UndefinedMetric }
      }

const OptionInfo ModeOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedMode },
        { "Concatenate", (long) ConcatenateMode },
        { "Frame", (long) FrameMode },
        { "Unframe", (long) UnframeMode },
        { (char *) NULL, (long) UndefinedMode }
      }

const OptionInfo MogrifyOptions[]`[static]`

Initial value:

      {
        { "append", MagickTrue },
        { "average", MagickTrue },
        { "clut", MagickTrue },
        { "coalesce", MagickTrue },
        { "combine", MagickTrue },
        { "composite", MagickTrue },
        { "crop", MagickTrue },
        { "debug", MagickTrue },
        { "deconstruct", MagickTrue },
        { "delete", MagickTrue },
        { "flatten", MagickTrue },
        { "fx", MagickTrue },
        { "insert", MagickTrue },
        { "layers", MagickTrue },
        { "limit", MagickTrue },
        { "map", MagickTrue },
        { "morph", MagickTrue },
        { "mosaic", MagickTrue },
        { "optimize", MagickTrue },
        { "process", MagickTrue },
        { "quiet", MagickTrue },
        { "separate", MagickTrue },
        { "scene", MagickTrue },
        { "swap", MagickTrue },
        { "write", MagickTrue },
        { (char *) NULL, MagickFalse }
      }

const OptionInfo NoiseOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedNoise },
        { "Gaussian", (long) (long) GaussianNoise },
        { "Impulse", (long) ImpulseNoise },
        { "Laplacian", (long) LaplacianNoise },
        { "Multiplicative", (long) MultiplicativeGaussianNoise },
        { "Poisson", (long) PoissonNoise },
        { "Random", (long) RandomNoise },
        { "Uniform", (long) UniformNoise },
        { (char *) NULL, (long) UndefinedNoise }
      }

const OptionInfo OrientationOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedOrientation },
        { "TopLeft", (long) TopLeftOrientation },
        { "TopRight", (long) TopRightOrientation },
        { "BottomRight", (long) BottomRightOrientation },
        { "BottomLeft", (long) BottomLeftOrientation },
        { "LeftTop", (long) LeftTopOrientation },
        { "RightTop", (long) RightTopOrientation },
        { "RightBottom", (long) RightBottomOrientation },
        { "LeftBottom", (long) LeftBottomOrientation }
      }

const OptionInfo PreviewOptions[]`[static]`

const OptionInfo PrimitiveOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedPrimitive },
        { "Arc", (long) ArcPrimitive },
        { "Bezier", (long) BezierPrimitive },
        { "Circle", (long) CirclePrimitive },
        { "Color", (long) ColorPrimitive },
        { "Ellipse", (long) EllipsePrimitive },
        { "Image", (long) ImagePrimitive },
        { "Line", (long) LinePrimitive },
        { "Matte", (long) MattePrimitive },
        { "Path", (long) PathPrimitive },
        { "Point", (long) PointPrimitive },
        { "Polygon", (long) PolygonPrimitive },
        { "Polyline", (long) PolylinePrimitive },
        { "Rectangle", (long) RectanglePrimitive },
        { "roundRectangle", (long) RoundRectanglePrimitive },
        { "Text", (long) TextPrimitive },
        { (char *) NULL, (long) UndefinedPrimitive }
      }

const OptionInfo QuantumFormatOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedQuantumFormat },
        { "FloatingPoint", (long) FloatingPointQuantumFormat },
        { "Signed", (long) SignedQuantumFormat },
        { "Unsigned", (long) UnsignedQuantumFormat },
        { (char *) NULL, (long) FloatingPointQuantumFormat }
      }

const OptionInfo ResolutionOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedResolution },
        { "PixelsPerInch", (long) PixelsPerInchResolution },
        { "PixelsPerCentimeter", (long) PixelsPerCentimeterResolution },
        { (char *) NULL, (long) UndefinedResolution }
      }

const OptionInfo ResourceOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedResource },
        { "Area", (long) AreaResource },
        { "Disk", (long) DiskResource },
        { "File", (long) FileResource },
        { "Map", (long) MapResource },
        { "Memory", (long) MemoryResource },
        { (char *) NULL, (long) UndefinedResource }
      }

const OptionInfo StorageOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedPixel },
        { "Char", (long) CharPixel },
        { "Double", (long) DoublePixel },
        { "Float", (long) FloatPixel },
        { "Integer", (long) IntegerPixel },
        { "Long", (long) LongPixel },
        { "Quantum", (long) QuantumPixel },
        { "Short", (long) ShortPixel },
        { (char *) NULL, (long) UndefinedResource }
      }

const OptionInfo StretchOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedStretch },
        { "Any", (long) AnyStretch },
        { "Condensed", (long) CondensedStretch },
        { "Expanded", (long) ExpandedStretch },
        { "ExtraCondensed", (long) ExtraCondensedStretch },
        { "ExtraExpanded", (long) ExtraExpandedStretch },
        { "Normal", (long) NormalStretch },
        { "SemiCondensed", (long) SemiCondensedStretch },
        { "SemiExpanded", (long) SemiExpandedStretch },
        { "UltraCondensed", (long) UltraCondensedStretch },
        { "UltraExpanded", (long) UltraExpandedStretch },
        { (char *) NULL, (long) UndefinedStretch }
      }

const OptionInfo StyleOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedStyle },
        { "Any", (long) AnyStyle },
        { "Italic", (long) ItalicStyle },
        { "Normal", (long) NormalStyle },
        { "Oblique", (long) ObliqueStyle },
        { (char *) NULL, (long) UndefinedStyle }
      }

const OptionInfo TypeOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedType },
        { "Bilevel", (long) BilevelType },
        { "ColorSeparation", (long) ColorSeparationType },
        { "ColorSeparationMatte", (long) ColorSeparationMatteType },
        { "Grayscale", (long) GrayscaleType },
        { "GrayscaleMatte", (long) GrayscaleMatteType },
        { "Optimize", (long) OptimizeType },
        { "Palette", (long) PaletteType },
        { "PaletteBilevelMatte", (long) PaletteBilevelMatteType },
        { "PaletteMatte", (long) PaletteMatteType },
        { "TrueColorMatte", (long) TrueColorMatteType },
        { "TrueColor", (long) TrueColorType },
        { (char *) NULL, (long) UndefinedType }
      }

const OptionInfo VirtualPixelOptions[]`[static]`

Initial value:

      {
        { "Undefined", (long) UndefinedVirtualPixelMethod },
        { "Background", (long) BackgroundVirtualPixelMethod },
        { "Black", (long) BlackVirtualPixelMethod },
        { "Constant", (long) BackgroundVirtualPixelMethod },
        { "Dither", (long) DitherVirtualPixelMethod },
        { "Edge", (long) EdgeVirtualPixelMethod },
        { "Gray", (long) GrayVirtualPixelMethod },
        { "Mirror", (long) MirrorVirtualPixelMethod },
        { "Random", (long) RandomVirtualPixelMethod },
        { "Tile", (long) TileVirtualPixelMethod },
        { "Transparent", (long) TransparentVirtualPixelMethod },
        { "White", (long) WhiteVirtualPixelMethod },
        { (char *) NULL, (long) UndefinedVirtualPixelMethod }
      }